# Use Auto DevOps pipeline
# https://gitlab.com/gitlab-org/gitlab/blob/master/lib/gitlab/ci/templates/Auto-DevOps.gitlab-ci.yml
include:
  - template: Auto-DevOps.gitlab-ci.yml

variables:
  # disable some auto devops tests
  BROWSER_PERFORMANCE_DISABLED: 1
  CODE_INTELLIGENCE_DISABLED: 1
  CODE_QUALITY_DISABLED: 1
  CONTAINER_SCANNING_DISABLED: 1
  DAST_DISABLED: 1
  DEPENDENCY_SCANNING_DISABLED: 1
  SAST_DISABLED: 1
  LICENSE_MANAGEMENT_DISABLED: 1
  LOAD_PERFORMANCE_DISABLED: 1
  PERFORMANCE_DISABLED: 1
  SECRET_DETECTION_DISABLED: 1
  CI_KUBERNETES_ACTIVE: 'true'
  TEST_DISABLED: 1

  # configure auto devops components
  STAGING_ENABLED: 1
  POSTGRES_ENABLED: 'false'

  # Agent
  KUBE_INGRESS_BASE_DOMAIN: dev.lincsproject.ca
  KUBE_CONTEXT: 'calincs/gitlab-agents:dev-agent'
  KUBE_NAMESPACE: $CI_PROJECT_NAME-$CI_ENVIRONMENT_SLUG

  # Application runtime variables
  K8S_SECRET_KEYCLOAK_BASE_URL: $KEYCLOAK_BASE_URL
  K8S_SECRET_SESSION_SECRET: $SESSION_SECRET
  K8S_SECRET_SPARQL_ENDPOINT: "https://fuseki.lincsproject.ca/lincs"
  K8S_SECRET_SPARQL_PWD: $SPARQL_PWD
  K8S_SECRET_SPACY_ENDPOINT: "https://spacy.lincsproject.ca/entities"

cache:
  paths:
    - node_modules

# deploy to dev
dev-deploy:
  extends: .auto-deploy
  stage: staging
  variables:
    KUBE_NAMESPACE: $CI_PROJECT_NAME-$CI_PROJECT_ID-dev
  script:
    - auto-deploy check_kube_domain
    - auto-deploy download_chart
    - auto-deploy use_kube_context || true
    - auto-deploy ensure_namespace
    - auto-deploy create_secret
    - auto-deploy deploy
  environment:
    name: dev
    url: https://lincs-api.$KUBE_INGRESS_BASE_DOMAIN
  rules:
    - if: '$CI_DEPLOY_FREEZE'
      when: never
    - if: '($CI_KUBERNETES_ACTIVE == null || $CI_KUBERNETES_ACTIVE == "") && ($KUBECONFIG == null || $KUBECONFIG == "")'
      when: never
    - if: '$INCREMENTAL_ROLLOUT_ENABLED'
      when: never
    - if: '$INCREMENTAL_ROLLOUT_MODE'
      when: never
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $STAGING_ENABLED'

# override some deployment parameters
staging:
  environment:
    name: staging
    url: https://lincs-api.$KUBE_INGRESS_BASE_DOMAIN
  variables:
    KUBE_INGRESS_BASE_DOMAIN: stage.lincsproject.ca
    KUBE_CONTEXT: 'calincs/gitlab-agents:stage-agent'
    KUBE_NAMESPACE: $CI_PROJECT_NAME-$CI_PROJECT_ID-staging
    K8S_SECRET_SPACY_ENDPOINT: "http://staging-auto-deploy.spacy-api-39986226-staging:5000/entities"

production_manual:
  environment:
    name: production
    url: https://lincs-api.$KUBE_INGRESS_BASE_DOMAIN
  variables:
    KUBE_INGRESS_BASE_DOMAIN: lincsproject.ca
    KUBE_CONTEXT: 'calincs/gitlab-agents:prod-agent'
    KUBE_NAMESPACE: $CI_PROJECT_NAME-$CI_PROJECT_ID-production
    K8S_SECRET_SPACY_ENDPOINT: "http://production-auto-deploy.spacy-api-39986226-production:5000/entities"
  before_script:
    - apk add --update npm
    - npm install
    - npm run build
    - npm config set -- '//registry.npmjs.org/:_authToken' "${NPM_AUTH_TOKEN}"
    - npm publish --workspace @lincs.project/lincs-api-contracts || true
